/* -------------------------------------------------------------------- */
/* Programma: conteggio    Modulo: funzioni.c    Autore: Enrico Lodolo  */
/* Creato il 16/12/2002                    Ultima modifica: 16/12/2002  */
/* -------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include "funzioni.h"

/* -------------------------------------------------------------------- */
/*  3. Definizione funzione leggi()                                     */
/*     Legge da nomefile i dati delle righe e nella struttura log...    */
/* -------------------------------------------------------------------- */

int leggi(char nomefile[], log* lg)
{
  riga r;
  FILE* f;

  f = fopen(nomefile, "r");

  if (f==NULL)
    return FALSE;
  else
  {
    lg->num = 0;

    while (fscanf(f, "%d/%d/%d %d:%d:%d %d",
	         &r.giorno, &r.mese, &r.anno,
           &r.ore, &r.minuti, &r.secondi, &r.giornosett)!=EOF)
    {
      lg->rg[lg->num] = r;
      lg->num++;
    }
    fclose(f);
    return TRUE;
  }
}

/* -------------------------------------------------------------------- */
/*  4. Definizione procedure conta()                                    */
/*     Conta il numero accessi per ogni giorno della settimana          */
/* ---------------------------------------------------------------------*/

void conta(log lg, int accessi[])

{
  int i;

	for (i=0;i<DIMACCESSI;i++)
	  accessi[i]=0;

  for (i=0;i<lg.num;i++)
		accessi[lg.rg[i].giornosett]++;
}

/* ------------------------------------------------------------------- */
/*  5. Definizione funzione scrivi()                                   */
/*     Scrive nel file filename i contatori degli accessi              */
/* --------------------------------------------------------------------*/

int scrivi(char nomefile[], int accessi[])
{
  FILE *f;
  int i;

  f = fopen(nomefile, "w");

  if (f==NULL) return FALSE;
  else
  {
    for(i=0; i<DIMACCESSI; i++)
      fprintf(f, "%d %d\n", i, accessi[i]);
    fclose(f);
    return TRUE;
  }
}

/* ------------------------------------------------------------------- */
/*  Definizione funzione errore() (non richiesta ma utile)             */
/*  Scrive a video un messaggio di errore e termina programma con      */
/*  valore di ritorno uguale al codice di errore                       */
/* --------------------------------------------------------------------*/

void errore(int n, char msg[])
{
  printf("%s\n",msg);
  exit(n);
}
